using System;

namespace Quik.Media.Color
{
    public static class FormatConvert
    {
        public static void Convert(QImageLock dst, QImageLock src)
        {
            if (dst.Format.IsU8() && src.Format.IsU8())
            {
                LockIO dstIO = new LockIO(dst);
                LockIO srcIO = new LockIO(src);

                int count = dst.Width * dst.Height * dst.Depth;
                for (int i = 0; i < count; i++)
                {
                    dstIO[i] = srcIO[i];
                }
            }
            else if (dst.Format.IsU8() && src.Format.IsFloat())
            {
                LockIO dstIO = new LockIO(dst);
                LockIOF srcIO = new LockIOF(src);

                int count = dst.Width * dst.Height * dst.Depth;
                for (int i = 0; i < count; i++)
                {
                    dstIO[i] = (QColor)srcIO[i];
                }
            }
            else if (dst.Format.IsFloat() && src.Format.IsU8())
            {
                LockIOF dstIO = new LockIOF(dst);
                LockIO srcIO = new LockIO(src);

                int count = dst.Width * dst.Height * dst.Depth;
                for (int i = 0; i < count; i++)
                {
                    dstIO[i] = (QColorF)srcIO[i];
                }
            }
            else if (dst.Format.IsFloat() && src.Format.IsFloat())
            {
                LockIOF dstIO = new LockIOF(dst);
                LockIOF srcIO = new LockIOF(src);

                int count = dst.Width * dst.Height * dst.Depth;
                for (int i = 0; i < count; i++)
                {
                    dstIO[i] = srcIO[i];
                }
            }
            else
            {
                throw new Exception("Congratulations you have broken image formats!");
            }
        }
    }
}